## CONTENTS OF THIS FILE
- [Introduction](#introduction)
- [Requirements](#requirements)
- [Installation](#installation)
- [Configuration](#configuration)
- [Maintainers](#maintainers)

## INTRODUCTION
Sends the webform data to the telegram group. A module containing a custom webform handler.

## REQUIREMENTS
This module requires the [wemform](https://www.drupal.org/project/webform) module.
  ```
  composer require drupal/webform
  ```

## INSTALLATION
***The installation of this module is like other Drupal modules.***
1. If your site is [managed via Composer](https://www.drupal.org/node/2718229), use Composer to download the webform module running
    ```
    composer require drupal/webform_telegram_notice
    ```
2. Enable the "Webform" and "webform_telegram_notice" modules. ```/admin/modules```

## CONFIGURATION
1.  Create a bot and get an API token
2.  Create a group and get the group ID
3.  Adding the bot token and group id to the module settings
4.  Creation of webform handler

### Create a bot and get an API token
- In the "Search" line, type @BotFather or follow the link t.me/botfather
- Press the "Menu" button and select the command /newbot
- Specify your username, and then its username, which should end with "bot"
- After successfully creating the bot, you will receive the bot's API token
<div style="text-align: left;"><img src="assets/images/create-bot.jpg" width="50%" /></div>

- Go to the created bot and run the command /start

### Create a group and get the group ID
- Creating a group in telegram
<div style="text-align: left;"><img src="assets/images/create-group.jpg" width="50%" /></div>

- Adding a previously created bot to this group
- We are writing the /start command in this group
- We insert this query in the browser line: ```https://api.telegram.org/bot<token>/getUpdates```
  **where is <token> changing your bot's API token**
- In the response, we are looking for ```"chat":{"id":  ``` That's what it is ***group ID***
<div style="text-align: left;"><img src="assets/images/json-request.jpg" width="50%" /></div>

##### Backup option for getting the group id:
- Opening telegram in the web version  ```https://web.telegram.org/a/```
- Go to the previously created group (from which we want to get the ID)
- Look at the browser line, example: ```https://web.telegram.org/a/#-977777777 ```
```-977777777``` - This is the group ID.
    
***Important: If you add multiple admins (supergroup) to a group, the group ID changes.***

### Adding the bot token and group id to the module settings
- Go to the module settings ```/admin/config/webform-telegram-notice/adminsettings```
- Filling in the necessary fields: **ID group** and **API token**
- **Exception fields** are the fields that we want to exclude from sending to telegram

### Creation of webform handler
- Go to the necessary form settings```/admin/structure/webform/manage/contact/handlers``` and click: **+ Add handler**
  Where **contact** is the machine name of the webform in which we want to configure sending to telegram
- We are looking for **Telegram webform handler** in the search. Adding it and saving it
<div style="text-align: left;"><img src="assets/images/add-handler.jpg" width="50%" /></div>

## MAINTAINERS
[![Static Badge](https://img.shields.io/badge/Maxim_Konovalov-Maxator-blue)](https://www.drupal.org/u/maxator)